; 
    include \masm32\include\masm32rt.inc
    .586	
    .xmm		
	include \masm32\macros\timers.asm

; 
comment *Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros - lingo *
.code
option prologue:none  ; turn it off
option epilogue:none  ;
align  16             ; 
bin2asciiL proc lpbuf:DWORD, nNumber:DWORD
mov 	eax, [esp+2*4]			; eax ->number
mov 	edx, 89705F41h 		; 1e-9 * 2^61 rounded
cmp eax,-1
mov	ecx, eax				;
je @f
add  eax, 1
@@:
mul 	edx 				; Divide by 1e9 by multiplying with reciprocal.
mov	[esp+2*4], edi			;
shr 	edx, 29 				; Leading decimal digit, 0...4
imul 	eax, edx, 1000000000 	; Leading digit * 1e9
mov	edi,  [esp+1*4]			; edi ->buffer
sub 	eax, ecx 			; Subtract (leading digit * 1e9) from argument.
lea	ecx,  [edx+30h]
mov 	edx, 0ABCC7712h 		; 2^28 / 1e8 * 2^30 rounded up
neg	eax
mul 	edx 				; Divide reduced
mov 	[edi], cl 				; Store leading digit
cmp 	ecx, 31h			; Any nonzero digit yet?
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
shr 	eax,  30 				; argument < 1e9 by 1e8,
lea 	eax,  [eax+4*edx+1]		; converting it into 4.28 fixed-point
mov 	edx, 0FFFFFFFh
and 	edx, eax ;  0FFFFFFFh 		; Fraction part

shr 	eax,  28 				; Next digit
add	ecx, eax
add 	eax,  30h 			; Convert digit to ASCII.
cmp 	ecx,  31h			; Any nonzero digit yet?
mov 	[edi], al 				; Store digit in memory
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
lea 	eax,  [edx*4+edx] 		; 5 * fraction, new digit EAX[31-27]
mov               edx,  7FFFFFFh  		; 5 * fraction, new fraction EDX[26-0]
and 	edx,  eax 			; Fraction part
shr 	eax,  27 				; Next digit
add	ecx,  eax
add 	eax,  30h 			; Convert digit to ASCII
mov 	[edi], al 				; Store digit in memory.
lea	eax,  [edx*4+edx+0C0000000h] ; 5 * fraction, new digit EAX[31-26]
cmp 	ecx,  31h 			; Any nonzero digit yet?
mov 	edx,  3FFFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and               edx,  eax			;
shr 	eax,  26 				; Next digit
or	ecx, eax

mov 	[edi], al 				; Store digit in memory.\
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+60000000h] ; 5 * fraction, new digit EAX[31-25]
mov 	edx,  1FFFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and 	edx,  eax			; Fraction part
shr 	eax,  25 				; Next digit
or	ecx, eax	
mov 	[edi], al 				; Store digit in memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+30000000h] ; 5 * fraction, new digit EAX[31-24]
mov 	edx,  0FFFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr, No, keep old ptr.
and	edx,  eax			;
shr 	eax,  24 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit in memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+18000000h] ; 5 * fraction, new digit EAX[31-23]
mov 	edx,  7FFFFFh 		; Fraction part

sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and	edx,  eax			;		
shr 	eax,  23 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit out to memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+0C000000h] ; 5 * fraction, new digit EAX[31-22]
mov 	edx,  3FFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and               edx,  eax			;
shr 	eax,  22 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit in memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+6000000h]  ; 5 * fraction, new digit EAX[31-21]
mov 	edx,  1FFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and 	edx,  eax			;
shr 	eax,  21 				; Next digit
mov 	[edi], al 				; Store digit in memory

or	ecx, eax
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+3000000h] ; 5 * fraction, new digit EAX[31-20]
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
shr 	eax,   20 			; Next digit
mov 	[edi],  ax 			; Store last digit and end marker in memory.
mov	edi,    [esp+2*4]		; Restore register as per calling convention
ret 	2*4 				; Pop two DWORD arguments and return
bin2asciiL	endp				; Total 88 instructions vs 101 from AMD
option prologue:prologuedef ; turn back on the defaults
option epilogue:epiloguedef ;                      



comment *Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros - AMD *
.code
option prologue:none  ; turn it off
option epilogue:none  ;
align  16             ; 
bin2ascii proc lpbuf:DWORD, nNumber:DWORD
push 	edi 				; Save as per calling conventions.
push 	ebx 				; Save as per calling conventions.
mov 	edi,  [esp+2*4+1*4]		; sptr ->buffer
mov 	eax, [esp+2*4+2*4]		; x ->number
mov 	ecx, eax 			; Save original argument.
mov 	edx, 89705F41h 		; 1e-9 * 2^61 rounded
mul 	edx 				; Divide by 1e9 by multiplying with reciprocal.
add 	eax, eax 			; Round division result.
adc 	edx, 0 			; EDX[31-29] = argument / 1e9
shr 	edx, 29 			; Leading decimal digit, 0...4
mov 	eax, edx 			; Leading digit
mov 	ebx, edx 			; Initialize digit accumulator with leading digit.
imul 	eax, 1000000000 		; Leading digit * 1e9
sub 	ecx, eax 			; Subtract (leading digit * 1e9) from argument.
or 	dl,    '0' 			; Convert leading digit to ASCII.
mov 	[edi], dl 			; Store leading digit.
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
mov 	eax, ecx 			; Get reduced argument < 1e9.
mov 	edx, 0ABCC7712h 		; 2^28 / 1e8 * 2^30 rounded up
mul 	edx 				; Divide reduced
shr 	eax, 30 			; argument < 1e9 by 1e8,
lea 	edx, [eax+4*edx+1]	; converting it into 4.28 fixed-point
mov 	eax, edx 			; format such that 1.0 = 2^28.
shr 	eax, 28 			; Next digit
and 	edx, 0FFFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-27]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[26-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 27 			; Next digit
and 	edx, 7FFFFFFh 		; Fraction part
or	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-26]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[25-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 26 			; Next digit
and 	edx, 3FFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-25]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[24-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 25 			; Next digit
and 	edx, 1FFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-24]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[23-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr, No, keep old ptr.
shr 	eax, 24 			; Next digit
and 	edx, 0FFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-23]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[31-23]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 23 			; Next digit
and 	edx, 7FFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit out to memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-22]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[22-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 22 			; Next digit
and 	edx, 3FFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit
or 	eax, '0'			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-21]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[21-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 21 			; Next digit
and 	edx, 1FFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-20]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 20 			; Next digit
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], ax 			; Store last digit and end marker in memory.
pop 	ebx 				; Restore register as per calling convention.
pop 	edi 				; Restore register as per calling convention.
ret 	2*4 				; Pop two DWORD arguments and return.
bin2ascii endp        ;
option prologue:prologuedef ; turn back on the defaults
option epilogue:epiloguedef ;    


.data
align 16
szBuffer   	db	30 Dup(0)  

.code
; 
start:
; 
    ;function tests


    invoke Sleep, 4000
    
    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	bin2ascii, addr szBuffer, 0FFFFFFFEh
    counter_end
    print ustr$(eax)," cycles, bin2ascii-AMD",13,10
    
   counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	bin2asciiL, addr szBuffer, 0FFFFFFFEh
    counter_end
    print ustr$(eax)," cycles, bin2ascii-lingo",13,10



    inkey "Press any key to exit..."
    exit
; 
end start



